﻿Type=StaticCode
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub GetNumeralFromString(strHebrewLetter As String) As String
	
	Select Case strHebrewLetter
		'Alef
		Case "05D0"
			Return 1
		
		'Bet	
		Case "05D1"
			Return 2
			
		'Gimel
		Case "05D2‎"
			Return 3
			
		'Dalet
		Case "05D3‎"
			Return 4
			
		'He
		Case "05D4‎"
			Return 5
			
		'Vav
		Case "05D5"
			Return 6
			
		'Zayin
		Case "05D6‎"
			Return 7
			
		'Het
		Case "‎05D7"
			Return 8
		
		'Tet
		Case "05D8"
			Return 9
			
		'Yod
		Case "05D9"
			Return 10
			
		'Kaf
		Case "05DAּ‎"
			Return 20
		Case "05DB"
			Return 20
			
		'Lamed	
		Case "05DC‎"
			Return 30
			
		'Mem
		Case "05DD‎"
			Return 40
		Case "05DE‎"
			Return 40
		
		'Nun	
		Case "05DF‎"
			Return 50
		Case "05E0‎"
			Return 50
			
		'Samekh
		Case "05E1‎"
			Return 60
		
		'Ayin
		Case "05E2‎"
			Return 70
		
		'Pe
		Case "05E3‎"
			Return 80
		Case "05E4‎"
			Return 80
		
		'Tsadik	
		Case "05E5‎"
			Return 90
		Case "05E6‎"
			Return 90
			
		'Qof
		Case "05E7‎"
			Return 100
		
		'Resh
		Case "05E8"
			Return 200
		
		'Shin
		Case "05E9"
			Return 300
		
		'Tav
		Case "05EA"
			Return 400
			
		Case Else
			Return 0

	End Select
End Sub
Sub GetAlphabetName(strHebrewLetter As String)
	Select Case strHebrewLetter
		'Alef
		Case "א‎": Return "Alef"
		
		'Bet	
		Case "ב": Return "Bet"
		Case "בּ‎": Return "Bet"
			
		'Gimel
		Case "ג‎": Return "Gimel"
			
		'Dalet
		Case "ד‎"
			
		'He
		Case "ה‎"
			
		'Vav
		Case "ו"
			
		'Zayin
		Case "ז‎"
			
		'Het
		Case "ח‎"
		
		'Tet
		Case "ט"
			
		'Yod
		Case "י"
			
		'Kaf
		Case "כּ‎"
		Case "כ"
		Case "ךּ‎"
		Case "ך"
		
		'Lamed	
		Case "ל‎"
			
		'Mem
		Case "מ‎"
		Case "ם‎"
		
		'Nun	
		Case "נ‎"
		Case "ן‎"
			
		'Samekh
		Case "ס‎"
		
		'Ayin
		Case "ע‎"
		
		'Pe
		Case "פּ‎"
		Case "פ‎"
		Case "ף‎"
		
		'Tsadik	
		Case "צ‎"
		Case "ץ‎"
			
		'Qof
		Case "ק‎"
		
		'Resh
		Case "ר"
		
		'Shin
		Case "שׂ"‎
		Case "שׁ"
		
		'Tav
		Case "תּ"
		Case "ת‎"
	End Select
End Sub
Sub GetTotalNumeralFromString(strhebrewLetter As String) As String
	Dim Total As Int
	Dim HeChar As String
	For x = 0 To strhebrewLetter.Length -1
		'Log(strhebrewLetter.SubString2(x,x+1))
		HeChar = strhebrewLetter.SubString2(x,x+1)
		HeChar = Bit.ToHexString(Asc(HeChar))
		If HeChar.Length = 3 Then HeChar = "0" & HeChar.ToUpperCase
		Total = Total + GetNumeralFromString(HeChar)
	Next
	
	Msgbox(Total, "")
	Return Total
End Sub

Sub UnescapeUnicode(s As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	Dim i As Int
	Do While i < s.Length
		Dim c As Char = s.CharAt(i)
		If c = "\" And i < s.Length - 1 And s.CharAt(i + 1) = "u" Then
			Dim unicode As StringBuilder
			unicode.Initialize
			i = i + 2
			Do While i < s.Length
				Dim cc As String = s.CharAt(i)
				Dim n As Int = Asc(cc.ToLowerCase)
				If (n >= Asc("0") And n <= Asc("9")) Or (n >= Asc("a") And n <= Asc("z")) Then
					unicode.Append(s.CharAt(i))
				Else
					i = i - 1
					Exit
				End If
				i = i + 1
			Loop
			sb.Append(Chr(Bit.ParseInt(unicode.ToString, 16)))
		Else
			sb.Append(c)
		End If
		i = i + 1
	Loop
	Log(sb.ToString)
	Return sb.ToString
End Sub